<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");


	LoadLib (
		"statistics"
	);

	// rule for counting unique visitors
	$AccessTable->set_rule("stats_counted",
		conf::Getkey("statistics", "count.interval", 60*60*12, "i"), // half a day
		1
	);

	// is this an unique visit?
	$hour = date("H");

	if (!$AccessTable->load_rule("stats_counted")) {

		// this visitor has not been counted

		if (isset($_SERVER["HTTP_USER_AGENT"])) {

			// user-agent string
			$userAgent = strtolower($_SERVER["HTTP_USER_AGENT"]);

			// guessing user agent
			$agentID = GEKKO_STATS_UNKNOWN_ID;
			foreach ($stats_user_agent as $id => $name) { // this array was defined in main.lib.php
				if (ereg($id, $userAgent)) {
					$agentID = $id;
					break;
				}
			}

			// guessing operative system
			$osID = GEKKO_STATS_UNKNOWN_ID;
			foreach ($stats_os as $id => $name) { // this array was defined in main.lib.php
				if (ereg($id, $userAgent)) {
					$osID = $id;
					break;
				}
			}

			// increasing counters for some other data
			Statistics::increaseCounter("user-agent", $agentID);
			Statistics::increaseCounter("user-agent-os", $osID);
		}

		// increasing _unique visitors_ counter for this day (for variant = 0)
		$q = $db->query("UPDATE ".db_table("stats_day")." SET
		h{$hour} = h{$hour}+1, total = total+1
		WHERE day = CURRENT_DATE() AND variant = '0'
		", __FILE__, __LINE__);

		if (!$db->affectedRows($q)) {

			// this is the first visitor today, setting counter to 1
			$db->query("INSERT INTO ".db_table("stats_day")." (
				day, h{$hour}, total, variant
			) VALUES (
				CURRENT_DATE(), 1, 1, 0
			)", __FILE__, __LINE__);

			// creating a row for this day
			$db->query("INSERT INTO ".db_table("stats_visits")."
			(day, uniquehits, total) VALUES (CURRENT_DATE(), 1, 1)",
			__FILE__, __LINE__);

		}

		Statistics::increaseCounter("total", "unique-visits");
	}

	// increasing _total hits_ counter for this day (variant = 1)
	$db->query("UPDATE ".db_table("stats_day")." SET
	h{$hour} = h{$hour}+1, total = total+1
	WHERE day = CURRENT_DATE() AND variant = '1'
	", __FILE__, __LINE__);

	if (!$db->affectedRows()) {
		// this is the first visitor today, setting counter to 1
		$db->query("INSERT INTO ".db_table("stats_day")." (
			day, h{$hour}, total, variant
		) VALUES (
			CURRENT_DATE(), 1, 1, 1
		)", __FILE__, __LINE__);
	}

	// synchonizing counters
	// unique visitors
	$db->query("UPDATE ".db_table("stats_visits")." v, ".db_table("stats_day")." d
	SET v.uniquehits = d.total WHERE v.day=d.day AND variant='0'",
	__FILE__, __LINE__);

	// total hits
	$db->query("UPDATE ".db_table("stats_visits")." v, ".db_table("stats_day")." d
	SET v.total = d.total WHERE v.day=d.day AND variant='1'",
	__FILE__, __LINE__);

	// increasing total clicks counter
	Statistics::increaseCounter("total", "clicks");


/*
	// specific search identificators
	if (preg_match("/http:\/\/(www\.|)(google\.[^\/]*)\/search(\?|.*&)q=([^&]*)(&|$)/i", $_SERVER["HTTP_REFERER"], $search)) {
		$search = array('engine' => $search[2], 'keywords' => urldecode($search[4]));
	} else if (preg_match("/http:\/\/(([^.]*\.|)search\.yahoo\.[^\/]*)\/search(\?|.*&)p=([^&]*)(&|$)/", $_SERVER["HTTP_REFERER"], $search)) {
		$search = array('engine' => $search[1], 'keywords' => urldecode($search[4]));
	} else if (preg_match("/http:\/\/(search(.*|)\.msn\.[^\/]*)\/results\.aspx(\?|.*&)q=([^&]*)(&|$)/", $_SERVER["HTTP_REFERER"], $search)) {
		$search = array('engine' => $search[1], 'keywords' => urldecode($search[4]));
	} else {
		...
	}
*/

	// referer log
	if (isset($_SERVER["HTTP_REFERER"]) && substr($_SERVER["HTTP_REFERER"], 0, strlen(_l("C_SITE.URL"))) != _l("C_SITE.URL")) {

		// updating counter only if this is an external referer
		$q = $db->query("UPDATE ".db_table("stats_uri_logs")."
		SET counter = counter + 1, date_access = CURRENT_TIMESTAMP(), last_ip = '".getIP()."'
		WHERE type = 'referer' AND url = '{$_SERVER["HTTP_REFERER"]}'
		", __FILE__, __LINE__);

		if (!$db->affectedRows($q)) {
			// counter doesn't exists, creating a new one
			$db->query("INSERT INTO ".db_table("stats_uri_logs")." (
				type, url, counter, last_ip, date_access
			) VALUES (
				'referer', '{$_SERVER["HTTP_REFERER"]}', 1, '".getIP()."', CURRENT_TIMESTAMP()
			)");
		}

		unset ($search);
		// using a generic search engine inspector
		if (preg_match("/http:\/\/([^\/]*)\/.*(search|web|)(\?|.*&)(q|query|qt|p)=([^&]*)(&|$)/", $_SERVER["HTTP_REFERER"], $search)) {
			$search = array('engine' => $search[1], 'keywords' => addslashes(stripslashes(urldecode($search[5]))));
		}

		if (isset($search['engine'])) {
			$q = $db->query("UPDATE ".db_table("stats_search_keywords")." SET
				counter = counter + 1,
				engine = '{$search["engine"]}',
				url = '{$_SERVER["REQUEST_URI"]}',
				referer = '{$_SERVER["HTTP_REFERER"]}'
			WHERE keywords = '{$search["keywords"]}'
			", __FILE__, __LINE__);

			if (!$db->affectedRows($q)) {
				$q = $db->query("INSERT INTO ".db_table("stats_search_keywords")." (
					counter, engine, url, keywords, referer, date_access
				) VALUES (
					'1',
					'{$search["engine"]}',
					'{$_SERVER["REQUEST_URI"]}',
					'{$search["keywords"]}',
					'{$_SERVER["HTTP_REFERER"]}',
					CURRENT_TIMESTAMP()
				)
				", __FILE__, __LINE__);
			}
		}
	}

	// URL hits log
	$q = $db->query("UPDATE ".db_table("stats_uri_logs")."
	SET counter = counter + 1, last_ip = '".getip()."'
	WHERE type = 'request' AND URL = '{$_SERVER["REQUEST_URI"]}'
	", __FILE__, __LINE__);

	if (!$db->affectedRows($q)) {
		// counter doesn't exists, creating a new one
		$db->query("INSERT INTO ".db_table("stats_uri_logs")." (
			type, url, counter, last_ip, date_access
		) VALUES (
			'request', '{$_SERVER["REQUEST_URI"]}', 1, '".getIP()."', CURRENT_TIMESTAMP()
		)");
	}
?>